require 'active_support/concern'

module Praetor
  module ServiceController
    extend ActiveSupport::Concern

    included do
      attr_reader :params
    end

    def serialize_collection(collection)
      serializer = ActiveModel::Serializer::ArraySerializer.new collection
      serialize_with serializer
    end

    def serialize(resource)
      serializer = "#{resource.class.name}Serializer".constantize.new resource
      serialize_with serializer
    end

    private

    def serialize_with(serializer)
      adapter = ActiveModel::Serializer::Adapter.create serializer
      adapter.as_json
    end
  end
end
